import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/menu/vue';
import { defineComponent, setup, $prefix, $props } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/menu-node/vue';
import { IconRightward, IconSearch } from '@opentinyvue/vue-icon';
import { addClass, removeClass } from '@opentinyvue/utils';
import Input from '@opentinyvue/vue-input';
import Exception from '@opentinyvue/vue-exception';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", _vm._g({}, _vm.on), [_vm._t("default")], 2);
};
var staticRenderFns$2 = [];
var __vue2_script$2 = {
  name: "MenuTransition",
  setup: function setup() {
    return {
      on: {
        beforeEnter: function beforeEnter(elem) {
          addClass(elem, "transition-[height] duration-300 ease-in-out");
          if (!elem.dataset) elem.dataset = {};
          elem.style.height = "0";
        },
        enter: function enter(elem) {
          elem.dataset.oldOverflow = elem.style.overflow;
          if (elem.scrollHeight === 0) {
            elem.style.height = "";
          } else {
            elem.style.height = elem.scrollHeight + "px";
          }
          elem.style.overflow = "hidden";
        },
        afterEnter: function afterEnter(elem) {
          removeClass(elem, "transition-[height] duration-300 ease-in-out");
          elem.style.height = "";
          elem.style.overflow = elem.dataset.oldOverflow;
        },
        beforeLeave: function beforeLeave(elem) {
          if (!elem.dataset) elem.dataset = {};
          elem.dataset.oldOverflow = elem.style.overflow;
          elem.style.height = elem.scrollHeight + "px";
          elem.style.overflow = "hidden";
        },
        leave: function leave(elem) {
          if (elem.scrollHeight === 0) return;
          addClass(elem, "transition-[height] duration-300 ease-in-out");
          elem.style.transitionProperty = "height";
          elem.style.height = 0;
        },
        afterLeave: function afterLeave(elem) {
          removeClass(elem, "transition-[height] duration-300 ease-in-out");
          elem.style.height = "";
          elem.style.overflow = elem.dataset.oldOverflow;
        }
      }
    };
  }
};
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var MenuTransition = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-full"
  }, [_c("div", {
    staticClass: "w-full hidden sm:block"
  }, [_c("div", {
    staticClass: "w-full px-2 mb-1",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.handelNodeClick(_vm.nodes);
      }
    }
  }, [_c("div", {
    staticClass: "relative w-full h-12 flex text-sm overflow-hidden cursor-pointer hover:bg-color-bg-2 rounded",
    class: [_vm.nodes.isCurrent ? "text-color-brand text-sm bg-color-fill-6 rounded hover:bg-color-brand-disabled" : "", _vm.currentPaths.includes(_vm.nodes.id) ? "text-color-brand" : "", _vm.nodes.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
    style: {
      "padding-left": _vm.depth * 24 + "px"
    }
  }, [_c("a", {
    staticClass: "flex items-center whitespace-normal",
    class: [_vm.nodes.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
    staticStyle: {
      "text-decoration": "none"
    },
    attrs: {
      "title": _vm.nodes.label,
      "href": _vm.nodes.url || void 0
    }
  }, [_vm.nodes.customIcon ? _c(_vm.nodes.customIcon, {
    tag: "component",
    class: [_vm.nodes.isCurrent ? "fill-color-brand" : _vm.nodes.disabled ? "fill-color-icon-disabled" : "fill-color-icon-primary"],
    attrs: {
      "custom-class": "mr-3 w-4.5 h-4.5 flex-shrink-0"
    }
  }) : _vm._e(), _c("span", {
    staticClass: "line-clamp-1"
  }, [_vm._v(_vm._s(_vm.nodes.label))])], 1), _vm.nodes.children && _vm.nodes.children.length ? _c("icon-rightward", {
    staticClass: "absolute right-3 top-4 transition-transform duration-300 ease-in-out",
    class: [_vm.nodes.isCurrent ? "fill-color-brand" : _vm.nodes.disabled ? "fill-color-icon-disabled" : "fill-color-icon-secondary", _vm.state.showNodes || _vm.nodes.visible ? "rotate-90" : ""]
  }) : _vm._e()], 1)]), _c("menu-transition", [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.showNodes || _vm.nodes.visible,
      expression: "state.showNodes || nodes.visible"
    }]
  }, _vm._l(_vm.nodes.children, function(node, index) {
    return _c("menu-node", {
      key: index,
      attrs: {
        "nodes": node,
        "label": node.label,
        "depth": _vm.depth + 1,
        "current-paths": _vm.currentPaths,
        "expanded-keys-path": _vm.expandedKeysPath,
        "actived-keys-path": _vm.activedKeysPath,
        "actived-keys": _vm.activedKeys
      }
    });
  }), 1)])], 1), _c("div", {
    staticClass: "w-full block sm:hidden"
  }, [_c("a", {
    staticClass: "w-full whitespace-normal text-sm leading-5.5 py-3 px-0 overflow-hidden line-clamp-2",
    class: [_vm.nodes.disabled || _vm.onlyCheckChildren && _vm.nodes.children ? "text-color-text-disabled cursor-not-allowed" : "", _vm.nodes.isCurrent ? "text-color-brand bg-color-bg-1" : ""],
    staticStyle: {
      "text-decoration": "none"
    },
    attrs: {
      "href": _vm.nodes.url || void 0
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.handelNodeClick(_vm.nodes);
      }
    }
  }, [_c("span", {
    staticClass: "relative px-4 line-clamp-2"
  }, [_vm._v(" " + _vm._s(_vm.nodes.label) + " "), _vm.nodes.isCurrent ? _c("i", {
    staticClass: "absolute left-0 top-0.5 w-0.5 bg-color-brand",
    staticStyle: {
      "height": "calc(100% - 6px)"
    }
  }) : _vm._e()])]), _vm.nodes.children ? _c("ul", _vm._l(_vm.nodes.children, function(node, index) {
    return _c("li", {
      key: index
    }, [_c("a", {
      staticClass: "block w-full whitespace-normal text-xs leading-5.5 py-3 px-0 overflow-hidden",
      class: [node.disabled ? "text-color-text-disabled cursor-not-allowed" : "", node.isCurrent ? "text-color-brand bg-color-bg-1" : ""],
      staticStyle: {
        "text-decoration": "none"
      },
      attrs: {
        "href": node.url || void 0
      },
      on: {
        "click": function click($event) {
          $event.stopPropagation();
          return _vm.handelNodeClick(node);
        }
      }
    }, [_c("span", {
      staticClass: "w-full relative pl-6 pr-4 line-clamp-2"
    }, [_vm._v(" " + _vm._s(node.label) + " "), node.isCurrent ? _c("i", {
      staticClass: "absolute left-0 top-0.5 w-0.5 bg-color-brand",
      staticStyle: {
        "height": "calc(100% - 6px)"
      }
    }) : _vm._e()])])]);
  }), 0) : _vm._e()])]);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = defineComponent({
  name: "MenuNode",
  emits: [],
  components: {
    MenuTransition,
    IconRightward: IconRightward()
  },
  props: _extends({}, $props, {
    activedKeys: [Number, String],
    nodes: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    currentPaths: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    depth: {
      type: Number,
      default: 0
    },
    activedKeysPath: {
      type: Array,
      default: function _default3() {
        return [];
      }
    },
    onlyCheckChildren: {
      type: Boolean,
      default: false
    },
    expandedKeysPath: {
      type: Array,
      default: function _default4() {
        return [];
      }
    }
  }),
  setup: function setup2(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var MenuNode = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "h-full pt-0 sm:pt-4 bg-color-bg-2 sm:bg-color-bg-1 overflow-y-auto",
    class: [_vm.widthAdapt ? "w-full" : "w-28 sm:w-56"],
    attrs: {
      "data-tag": "tiny-menu"
    }
  }, [_vm.showFilter ? _c("div", {
    staticClass: "px-6 pb-3 pt-0 hidden sm:block [&_svg]:fill-color-text-placeholder",
    attrs: {
      "data-tag": "tiny-menu-filter"
    }
  }, [_c("tiny-input", {
    attrs: {
      "suffix-icon": _vm.searchIcon,
      "placeholder": _vm.t("ui.treeMenu.placeholder")
    },
    on: {
      "update:modelValue": function updateModelValue($event) {
        return _vm.filterInput($event);
      }
    },
    model: {
      value: _vm.state.filterText,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "filterText", $$v);
      },
      expression: "state.filterText"
    }
  })], 1) : _vm._e(), _vm.state.isEmpty ? _c("div", {
    staticClass: "relative w-full min-h-[theme(spacing.16)]",
    attrs: {
      "data-tag": "tiny-menu-empty"
    }
  }, [_c("tiny-exception", {
    attrs: {
      "component-page": "",
      "type": "noresult",
      "tiny_mode": "mobile-first",
      "tiny_mode_root": ""
    }
  })], 1) : _vm._e(), !_vm.data.length ? _c("div", {
    attrs: {
      "data-tag": "tiny-slot-empty"
    }
  }, [_vm._t("empty", function() {
    return [_c("div", {
      staticClass: "relative w-full min-h-[theme(spacing.16)] flex justify-center items-center"
    }, [_c("span", [_vm._v(_vm._s(_vm.emptyText || _vm.t("ui.tree.emptyText")))])])];
  })], 2) : _vm._e(), _vm._l(_vm.state.filterValue ? _vm.state.filterData : _vm.state.data, function(item, index) {
    return _c("menu-node", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !item.hidden,
        expression: "!item.hidden"
      }],
      key: item.id || index,
      attrs: {
        "nodes": item,
        "depth": 1,
        "current-paths": _vm.state.currentPaths,
        "expanded-keys-path": _vm.state.expandedKeysPath,
        "actived-keys-path": _vm.state.activedKeysPath,
        "actived-keys": _vm.state.activedKeys,
        "only-check-children": _vm.onlyCheckChildren
      }
    });
  })], 2);
};
var staticRenderFns = [];
var __vue2_script = defineComponent({
  name: $prefix + "Menu",
  componentName: "Menu",
  emits: ["current-change", "node-click", "node-clicked", "node-changed"],
  components: {
    MenuNode,
    TinyInput: Input,
    TinyException: Exception
  },
  props: _extends({}, $props, {
    showFilter: {
      type: Boolean,
      default: false
    },
    searchIcon: {
      type: Object,
      default: function _default5() {
        return IconSearch();
      }
    },
    emptyText: {
      type: String,
      default: ""
    },
    expandedKeys: {
      type: Array,
      default: function _default6() {
        return [];
      }
    },
    activedKeys: {
      type: [Number, String],
      default: ""
    },
    onlyCheckChildren: {
      type: Boolean,
      default: false
    },
    expandAll: {
      type: Boolean,
      default: false
    },
    data: {
      type: Array,
      default: function _default7() {
        return [];
      }
    },
    widthAdapt: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup3(props, context) {
    return setup({
      props,
      context,
      renderless: renderless$1,
      api: api$1,
      mono: true
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Menu = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.22.0";
Menu.install = function(Vue) {
  Vue.component(Menu.name, Menu);
};
Menu.version = version;

export { Menu as default };
